/****************************************************************************
**  BrowserTickTock - Timer/Clock/Alarm add-on for Mozilla
**  Copyright (c) 2003  Charles Melhorn
**
**  This file is part of BrowserTickTock.
**
**  BrowserTickTock is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  BrowserTickTock is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
**  Or see the GNU web site at: http://www.gnu.org
**
****************************************************************************/ 

var gAlarmInfo_TimerID = null;

function initInfo()
{
  var currenttime = new Date();

  document.getElementById("alarm-time-display").value = window.opener.dateToClock(window.opener.gBTTClockController.targetDate);
  document.getElementById("current-time-display").value = window.opener.dateToClock(currenttime);
  document.getElementById("timeremaining-display").value = window.opener.calculateTimeRemaining(currenttime);
  document.getElementById("remindermsg-desc").value = window.opener.gBTTClockController.reminder_msg;

  var auto_reset_str = gBTTUserPreferenceInfo.getPrefValue("auto_reset") ? "ON" : "OFF";
  document.getElementById("autoreset-display").value = auto_reset_str;

  gAlarmInfo_TimerID = setInterval( "updateAlarmInfo()", 5000 );

}


function updateAlarmInfo()
{
  var currenttime = new Date();

  document.getElementById("current-time-display").value = window.opener.dateToClock(currenttime);
  document.getElementById("timeremaining-display").value = window.opener.calculateTimeRemaining(currenttime);

}


function cleanUp()
{
  if (gAlarmInfo_TimerID != null)
    clearInterval(gAlarmInfo_TimerID);

}
