/****************************************************************************
**  BrowserTickTock - Timer/Clock/Alarm add-on for Mozilla
**  Copyright (c) 2004-2005  Charles Melhorn
**
**  This file is part of BrowserTickTock.
**
**  BrowserTickTock is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  BrowserTickTock is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
**  Or see the GNU web site at: http://www.gnu.org
**
****************************************************************************/ 


function enableCuckooSoundsGroup(bEnable)
{
  document.getElementById('cuckoo-soundpreview-btn').disabled = !bEnable;
  document.getElementById('cuckoo-browse-btn').disabled = !bEnable;

  var cuck_sounds_rgroup = document.getElementById('cuckoo-sounds-rgroup');
  cuck_sounds_rgroup.disabled = !bEnable;

  if (bEnable)
    ConfigureClockPanel(cuck_sounds_rgroup.selectedItem.value);
}


function ConfigureClockPanel(sel_option)
{ 
  var cuck_sound_prev_btn = document.getElementById('cuckoo-soundpreview-btn');
  var cuck_custom_sound_tbox = document.getElementById('cuckoo-customfile-tbox');
  var cuck_sound_browse_btn = document.getElementById('cuckoo-browse-btn');

  if ((sel_option == "announce") || (sel_option == "standard"))
   {
    cuck_sound_prev_btn.disabled = false;
    cuck_custom_sound_tbox.disabled = true;
    cuck_sound_browse_btn.disabled = true;

    if (sel_option == "standard")
     {
       var cuckoo_standsounds_lbox = document.getElementById('cuckoo-standsounds-lbox');
       var selected_sound = cuckoo_standsounds_lbox.selectedItem;

       if (!selected_sound)                         // make sure there is a
         cuckoo_standsounds_lbox.selectedIndex = 0; // standard sound selection
     }
   }
  else if (sel_option == "custom")
   {
    cuck_sound_browse_btn.disabled = false;
    cuck_custom_sound_tbox.disabled = false;
    cuck_sound_prev_btn.disabled = (cuck_custom_sound_tbox.value == "");
   }

}


function enableAlarmSoundsGroup(bEnable)
{
  document.getElementById('alarm-soundpreview-btn').disabled = !bEnable;
  document.getElementById('alarm-browse-btn').disabled = !bEnable;

  var alarm_sounds_rgroup = document.getElementById('alarm-sounds-rgroup');
  alarm_sounds_rgroup.disabled = !bEnable;

  if (bEnable)
    ConfigureAlarmPanel(alarm_sounds_rgroup.selectedItem.value);
}


function ConfigureAlarmPanel(sel_option)
{ 
  var alarm_sound_prev_btn = document.getElementById('alarm-soundpreview-btn');
  var alarm_custom_sound_tbox = document.getElementById('alarm-customfile-tbox');
  var alarm_sound_browse_btn = document.getElementById('alarm-browse-btn');

  if ((sel_option == "announce") || (sel_option == "standard"))
   {
    alarm_sound_prev_btn.disabled = false;
    alarm_custom_sound_tbox.disabled = true;
    alarm_sound_browse_btn.disabled = true;

    if (sel_option == "standard")
     {
       var alarm_standsounds_lbox = document.getElementById('alarm-standsounds-lbox');
       var selected_sound = alarm_standsounds_lbox.selectedItem;

       if (!selected_sound)                         // make sure there is a
         alarm_standsounds_lbox.selectedIndex = 0;  // standard sound selection
     }
   }
  else if (sel_option == "custom")
   {
    alarm_sound_browse_btn.disabled = false;
    alarm_custom_sound_tbox.disabled = false;
    alarm_sound_prev_btn.disabled = (alarm_custom_sound_tbox.value == "");
   }

}


function browseAlarmSoundFiles(sfile_str)
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
           .createInstance(nsIFilePicker);

  fp.init(window, "Select a File", nsIFilePicker.modeOpen);
  fp.appendFilter("Audio Files","*.wav");

  var res = fp.show();

  if (res == nsIFilePicker.returnOK)
   {
     var custom_snd_file=fp.file;
     document.getElementById('alarm-customfile-tbox').value = fp.fileURL.spec;
     document.getElementById('alarm-soundpreview-btn').disabled = false;
   }

}


function browseCuckooSoundFiles(sfile_str)
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
           .createInstance(nsIFilePicker);

  fp.init(window, "Select a File", nsIFilePicker.modeOpen);
  fp.appendFilter("Audio Files","*.wav");

  var res = fp.show();

  if (res == nsIFilePicker.returnOK)
   {
     document.getElementById("cuckoo-customfile-tbox").value = fp.fileURL.spec;
     document.getElementById("cuckoo-soundpreview-btn").disabled = false;
   }

}


function playSoundFile(sfile_str)
{
  // this code works for chrome:// and http:// URLs,
  // but not for file:// URLs

  var sample = Components.classes["@mozilla.org/sound;1"].createInstance();
  sample = sample.QueryInterface(Components.interfaces.nsISound);
  const SND_NETWORK_STD_CID = "@mozilla.org/network/standard-url;1";
  const SND_I_URL           = "nsIURL";
  const SND_URL             = new Components.Constructor(SND_NETWORK_STD_CID, SND_I_URL);
  var url                   = new SND_URL();
  url.spec                  = "chrome://browserticktock/content/" + sfile_str;
  sample.play(url);

}


function playSoundURL(sURL_str)
{
  var sample = Components.classes["@mozilla.org/sound;1"].createInstance();
  sample = sample.QueryInterface(Components.interfaces.nsISound);
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                  .getService(Components.interfaces.nsIIOService);
  var url = ioService.newURI(sURL_str, null, null);
  sample.play(url);

}


function PreviewCuckooSound()
{
  var cuck_sounds_rgroup = document.getElementById('cuckoo-sounds-rgroup');
  var sel_option = cuck_sounds_rgroup.selectedItem.value;

  if (sel_option == "standard")
   {
     var selected_sound = (document.getElementById('cuckoo-standsounds-lbox')).selectedItem;

     if (selected_sound)
      {
        var filename = selected_sound.value;
        playSoundFile(filename);
      }
   }
  else if (sel_option == "custom")
   {
     var soundfileURL_str = document.getElementById('cuckoo-customfile-tbox').value;

     if (soundfileURL_str != "")
       playSoundURL(soundfileURL_str);
   }

}


function PreviewAlarmSound()
{
  var alarm_sounds_rgroup = document.getElementById('alarm-sounds-rgroup');
  var sel_option = alarm_sounds_rgroup.selectedItem.value;

  if (sel_option == "standard")
   {
     var selected_sound = (document.getElementById('alarm-standsounds-lbox')).selectedItem;

     if (selected_sound)
      {
        var filename = selected_sound.value;
        playSoundFile(filename);
      }
   }
  else if (sel_option == "custom")
   {
     var soundfileURL_str = document.getElementById('alarm-customfile-tbox').value;

     if (soundfileURL_str != "")
       playSoundURL(soundfileURL_str);
   }

}


function initPrefDialog()
{
  // clock panel

  var clockcolor_cb = document.getElementById("btt-clockcolor-cbox"); 
  clockcolor_cb.checked = gBTTUserPreferenceInfo.getPrefValue("use_clock_color");

  var clockcolor_cp = document.getElementById("btt-clockcolor-cpick");

  if (clockcolor_cb.checked)
    clockcolor_cp.color = gBTTUserPreferenceInfo.getPrefValue("clocktext_color");
  else
    clockcolor_cp.color = "";  // can't disable color picker in FF <= 1.0, so
                               // just set color to empty string

  var clockformat_rgroup = document.getElementById("clock-format-rgroup"); 
  var clockformat = gBTTUserPreferenceInfo.getPrefValue("clock_format");
  var ele_arr = clockformat_rgroup.getElementsByAttribute("value", String(clockformat));
  clockformat_rgroup.selectedItem = ele_arr[0];

  var dateformat_db = document.getElementById("date-format-dropbox"); 
  dateformat_db.value = gBTTUserPreferenceInfo.getPrefValue("date_format");

  var cuckoointerval_rgroup = document.getElementById("cuckoo-interval-rgroup"); 
  var cuckoointerval = gBTTUserPreferenceInfo.getPrefValue("cuckoo_interval");
  var ele_arr = cuckoointerval_rgroup.getElementsByAttribute("value", String(cuckoointerval));
  cuckoointerval_rgroup.selectedItem = ele_arr[0];

  var cuckoosound_cb = document.getElementById("cuckoo-sound-cbox"); 
  cuckoosound_cb.checked = gBTTUserPreferenceInfo.getPrefValue("cuckoo_playsound");

  var cuckoo_sounds_rgroup = document.getElementById('cuckoo-sounds-rgroup');
  var cuckoosoundtype = gBTTUserPreferenceInfo.getPrefValue("cuckoo_sound_type");
  var ele_arr = cuckoo_sounds_rgroup.getElementsByAttribute("value", cuckoosoundtype);
  cuckoo_sounds_rgroup.selectedItem = ele_arr[0];

  var cuckoo_standsounds_lbox = document.getElementById('cuckoo-standsounds-lbox');

  if (cuckoosoundtype == "standard")
   {
     cuckoo_standsounds_lbox.value = gBTTUserPreferenceInfo.getPrefValue("cuckoo_sound_file");
     cuckoo_standsounds_lbox.ensureElementIsVisible(cuckoo_standsounds_lbox.selectedItem);
   }
  else if (cuckoosoundtype == "custom")
   {
     var cuckoo_customsound_tbox = document.getElementById("cuckoo-customfile-tbox");
     cuckoo_customsound_tbox.value = gBTTUserPreferenceInfo.getPrefValue("cuckoo_sound_file");
   }

  enableCuckooSoundsGroup(cuckoosound_cb.checked);


  // alarm panel

  var alarm_timeout_tbox = document.getElementById('alarm-timeout-tbox');
  alarm_timeout_tbox.value = gBTTUserPreferenceInfo.getPrefValue("alarm_timeout");

  var autoreset_cb = document.getElementById("alarm-autoreset-cbox"); 
  autoreset_cb.checked = gBTTUserPreferenceInfo.getPrefValue("auto_reset");

  var fixedsnooze_cb = document.getElementById("use-fixed-snooze-cbox"); 
  fixedsnooze_cb.checked = gBTTUserPreferenceInfo.getPrefValue("use_fixed_snooze");

  var snooze_increment_tbox = document.getElementById('snooze-increment-tbox');
  snooze_increment_tbox.value = gBTTUserPreferenceInfo.getPrefValue("snooze_increment");
  snooze_increment_tbox.disabled = !fixedsnooze_cb.checked;


  var alarmpopup_cb = document.getElementById("alarm-popup-cbox"); 
  alarmpopup_cb.checked = gBTTUserPreferenceInfo.getPrefValue("alarm_popwindow");

  var alarmflash_cb = document.getElementById("alarm-flashbrowser-cbox"); 
  alarmflash_cb.checked = gBTTUserPreferenceInfo.getPrefValue("alarm_flashbrowser");

  var alarmslider_cb = document.getElementById("alarm-slider-cbox"); 
  alarmslider_cb.checked = gBTTUserPreferenceInfo.getPrefValue("alarm_showslider");

  var alarmloadurl_cb = document.getElementById("alarm-loadurl-cbox"); 
  alarmloadurl_cb.checked = gBTTUserPreferenceInfo.getPrefValue("alarm_loadurl");

  var alarm_url_tbox = document.getElementById("alarm-url-tbox");
  alarm_url_tbox.value = gBTTUserPreferenceInfo.getPrefValue("alarm_url");

  enableAlarmUrlInputs(alarmloadurl_cb.checked);

  var alarmplaysound_cb = document.getElementById("alarm-playsound-cbox"); 
  alarmplaysound_cb.checked = gBTTUserPreferenceInfo.getPrefValue("alarm_playsound");

  var alarmsounds_rgroup = document.getElementById("alarm-sounds-rgroup"); 
  var alarmsoundtype = gBTTUserPreferenceInfo.getPrefValue("alarm_sound_type");
  var ele_arr = alarmsounds_rgroup.getElementsByAttribute("value", alarmsoundtype);
  alarmsounds_rgroup.selectedItem = ele_arr[0];

  var alarm_standsounds_lbox = document.getElementById('alarm-standsounds-lbox');

  if (alarmsoundtype == "standard")
   {
     alarm_standsounds_lbox.value = gBTTUserPreferenceInfo.getPrefValue("alarm_sound_file");
     alarm_standsounds_lbox.ensureElementIsVisible(alarm_standsounds_lbox.selectedItem);
   }
  else if (alarmsoundtype == "custom")
   {
     var alarm_customsound_tbox = document.getElementById("alarm-customfile-tbox");
     alarm_customsound_tbox.value = gBTTUserPreferenceInfo.getPrefValue("alarm_sound_file");
   }

  enableAlarmSoundsGroup(alarmplaysound_cb.checked);


  // advanced panel

  var update_interval_tbox = document.getElementById("update-interval-tbox");
  update_interval_tbox.value = gBTTUserPreferenceInfo.getPrefValue("update_interval");

  var browseruptime_cb = document.getElementById("calc-browseruptime-cbox"); 
  browseruptime_cb.checked = gBTTUserPreferenceInfo.getPrefValue("compute_uptime");

}


function enableClockColorPicker(bEnable)
{
  var clockcolor_cp = document.getElementById("btt-clockcolor-cpick");

  if (bEnable)
    clockcolor_cp.color = "#000000";
  else
    clockcolor_cp.color = "";
}


function EnableSnoozeBox(bEnable)
{
  document.getElementById('snooze-increment-tbox').disabled = (bEnable ? false : true);

}


function insertCurrentPage()
{
//  alert(opener.getWebNavigation().currentURI.spec);
alert("top: ", top);
/*
  if (top.opener) {
    var homePageField = document.getElementById("browserStartupHomepage");
    var newVal = "";

    var tabbrowser = top.opener.document.getElementById("content");
    var l = tabbrowser.browsers.length;
    for (var i = 0; i < l; i++) {
      if (i)
        newVal += "|";
      newVal += tabbrowser.getBrowserAtIndex(i).webNavigation.currentURI.spec;
    }
    
    homePageField.value = newVal;
  }
*/
}


function setAlarmUrlToBookmark()
{
  var isNavigator = (
    ("nsIXULAppInfo" in Components.interfaces) &&
    (Components.classes["@mozilla.org/xre/app-info;1"]
    .getService(Components.interfaces.nsIXULAppInfo)
    .ID == "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}") ||
    (Components.classes["@mozilla.org/xre/app-info;1"]
    .getService(Components.interfaces.nsIXULAppInfo)
    .ID == "{a3210b97-8e8a-4737-9aa0-aa0e607640b9}"));
  var unsupported = (
    ("nsIXULAppInfo" in Components.interfaces) &&
    (Components.classes["@mozilla.org/xre/app-info;1"]
    .getService(Components.interfaces.nsIXULAppInfo)
    .ID == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") ||
    (Components.classes["@mozilla.org/xre/app-info;1"]
    .getService(Components.interfaces.nsIXULAppInfo)
    .ID == "{4523665a-317f-4a66-9376-3763d1ad1978}"));
  var url = isNavigator ?
              "chrome://browserticktock/content/selectBookmarkSM.xul" :
              unsupported ?
                "chrome://browserticktock/content/notSupported.xul" :
                "chrome://browserticktock/content/selectBookmark.xul"
  var rv = { urls: null, names: null };
  openDialog(url, "", 
             "centerscreen,chrome,modal=yes,dialog=yes,resizable=yes", rv);
  if (rv.urls && rv.names) {
    var alarmUrlField = document.getElementById("alarm-url-tbox");
    alarmUrlField.value = rv.urls.join("|");
  }
}


function setAlarmUrlToCurrentPage()
{
  var alarmUrlField = document.getElementById("alarm-url-tbox");
  var newVal = "";
  var tabbrowser;

  // use the opener browser's current page(s) unless preferences dialog
  // wasn't opened from browser window (e.g. from the extensions window)
  try {
    tabbrowser = opener.getBrowser();

  } catch (e) {
    tabbrowser = getTopWin().document.getElementById("content");
  }

  var l = tabbrowser.browsers.length;
  for (var i = 0; i < l; i++)
   {
     if (i)
       newVal += "|";
     newVal += tabbrowser.browsers[i].webNavigation.currentURI.spec;
   }
    
  alarmUrlField.value = newVal;

}


function enableAlarmUrlInputs(bEnable)
{
  document.getElementById('alarm-url-tbox').disabled = !bEnable;
  document.getElementById('btt-urlchoices-btn').disabled = !bEnable;
}


function doOK()
{
  var snooze_increment_str, snooze_increment_Int;


  // clock panel

  var clockcolor_cb = document.getElementById("btt-clockcolor-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("use_clock_color", clockcolor_cb.checked);

  var clockcolor_cp = document.getElementById("btt-clockcolor-cpick");
  gBTTUserPreferenceInfo.setPrefValue("clocktext_color", clockcolor_cp.color);

  var clockformat_rgroup = document.getElementById("clock-format-rgroup"); 
  var clockformat = parseInt(clockformat_rgroup.selectedItem.value);
  gBTTUserPreferenceInfo.setPrefValue("clock_format", clockformat);

  var dateformat_db = document.getElementById("date-format-dropbox"); 
  gBTTUserPreferenceInfo.setPrefValue("date_format", dateformat_db.value);

  var cuckoointerval_rgroup = document.getElementById("cuckoo-interval-rgroup"); 
  var cuckoointerval = parseInt(cuckoointerval_rgroup.selectedItem.value);
  gBTTUserPreferenceInfo.setPrefValue("cuckoo_interval", cuckoointerval);

  var cuckoosound_cb = document.getElementById("cuckoo-sound-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("cuckoo_playsound", cuckoosound_cb.checked);

  if (cuckoosound_cb.checked) // only update cuckoo sound prefs if "play sound" is true
   {
     var cuckoo_customsound_tbox = document.getElementById("cuckoo-customfile-tbox");
     var cuckoo_sounds_rgroup = document.getElementById('cuckoo-sounds-rgroup');
     var cuckoosoundtype = cuckoo_sounds_rgroup.selectedItem.value;;

     if ( (cuckoosoundtype == "custom") && (cuckoo_customsound_tbox.value == ""))
      {
        alert("Please supply custom cuckoo sound file name");
        return false;
      }
     else
      {
        gBTTUserPreferenceInfo.setPrefValue("cuckoo_sound_type", cuckoosoundtype);

        if (cuckoosoundtype == "standard")
         {
           var selected_sound = document.getElementById('cuckoo-standsounds-lbox').selectedItem;

           if (selected_sound)
             gBTTUserPreferenceInfo.setPrefValue("cuckoo_sound_file", selected_sound.value);
         }
        else if (cuckoosoundtype == "custom")
         {
           var cuckoosoundfile = cuckoo_customsound_tbox.value;
           gBTTUserPreferenceInfo.setPrefValue("cuckoo_sound_file", cuckoosoundfile);
         }
      }
   }


  // alarm panel

  var alarm_timeout_tbox = document.getElementById('alarm-timeout-tbox');
  gBTTUserPreferenceInfo.setPrefValue("alarm_timeout", parseInt(alarm_timeout_tbox.value));

  var autoreset_cb = document.getElementById("alarm-autoreset-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("auto_reset", autoreset_cb.checked);

  var fixedsnooze_cb = document.getElementById("use-fixed-snooze-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("use_fixed_snooze", fixedsnooze_cb.checked);

  var snooze_increment_tbox = document.getElementById('snooze-increment-tbox');

  if (fixedsnooze_cb.checked == true)
   {
    snooze_increment_str = snooze_increment_tbox.value;

    if (snooze_increment_str == "")
      snooze_increment_Int = 0;
    else
      snooze_increment_Int = parseInt(snooze_increment_str);

    if (snooze_increment_Int < 1)  // minimum snooze value is 1
      snooze_increment_Int = 1;

    gBTTUserPreferenceInfo.setPrefValue("snooze_increment", snooze_increment_Int);
   }


  var alarmpopup_cb = document.getElementById("alarm-popup-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("alarm_popwindow", alarmpopup_cb.checked);

  var alarmflash_cb = document.getElementById("alarm-flashbrowser-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("alarm_flashbrowser", alarmflash_cb.checked);

  var alarmslider_cb = document.getElementById("alarm-slider-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("alarm_showslider", alarmslider_cb.checked);

  var alarmloadurl_cb = document.getElementById("alarm-loadurl-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("alarm_loadurl", alarmloadurl_cb.checked);

  if (alarmloadurl_cb.checked)
   {
     var alarm_url_tbox = document.getElementById("alarm-url-tbox"); 
     gBTTUserPreferenceInfo.setPrefValue("alarm_url", alarm_url_tbox.value);
   }

  var alarmplaysound_cb = document.getElementById("alarm-playsound-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("alarm_playsound", alarmplaysound_cb.checked);

  if (alarmplaysound_cb.checked) // only update alarm sound prefs if "play sound" is true
   {
     var alarm_customsound_tbox = document.getElementById('alarm-customfile-tbox');
     var alarmsounds_rgroup = document.getElementById("alarm-sounds-rgroup"); 
     var alarmsoundtype = alarmsounds_rgroup.selectedItem.value;

     if ( (alarmsoundtype == "custom") && (alarm_customsound_tbox.value == ""))
      {
        alert("Please supply custom alarm sound file name");
        return false;
      }
     else
      {
        gBTTUserPreferenceInfo.setPrefValue("alarm_sound_type", alarmsoundtype);

        if (alarmsoundtype == "standard")
         {
           var selected_sound = (document.getElementById('alarm-standsounds-lbox')).selectedItem;

           if (selected_sound)
             gBTTUserPreferenceInfo.setPrefValue("alarm_sound_file", selected_sound.value);
         }
        else if (alarmsoundtype == "custom")
         {
           var alarmsoundfile = alarm_customsound_tbox.value;
           gBTTUserPreferenceInfo.setPrefValue("alarm_sound_file", alarmsoundfile);
         }
      }
   }


  // advanced panel

  var update_interval_tbox = document.getElementById("update-interval-tbox");
  var update_interval = parseInt(update_interval_tbox.value);

  if (update_interval <= 0)  // disallow zero and negative values
    update_interval = 1;

  gBTTUserPreferenceInfo.setPrefValue("update_interval", update_interval);

  var browseruptime_cb = document.getElementById("calc-browseruptime-cbox"); 
  gBTTUserPreferenceInfo.setPrefValue("compute_uptime", browseruptime_cb.checked);


  return true
}


// borrowed from utilityOverlay.js
function getTopWin()
{
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    var topWindowOfType = windowManagerInterface.getMostRecentWindow( "navigator:browser" );

    if (topWindowOfType) {
        return topWindowOfType;
    }
    return null;
}
